Subject: Re: bug#57372: no-toolkit menu popups do not respect emacs font configuration

From: Eli Zaretskii <[email-masked]>
Date: Thu, 25 Aug 2022 09:42:00 +0300

> From: Tomas Hlavaty <[email-masked]>
> Cc: [email-masked], [email-masked]
> Date: Wed, 24 Aug 2022 23:57:44 +0200
> 
> > Of course, X doesn't necessarily understand the Emacs units of
> > measuring fonts, for example the relative units.  So eventually you'll
> > need separate customizations.  However, I don't expect you to have to
> > change these customizations too frequently.
> 
> The point of C-+ and C-- bindings is that I can just press a key and
> grow or shrink the font.  That is essential for me.  My gui terminal can
> do that out of the box, my console can do that with a bit of elisp
> calling setfont, firefox can do that out of the box, and gui Emacs can
> do that using the code I showed earlier; except the menu text we are
> discussing.
> 
> This font size change happens on demand, when a key is pressed.

Do you really need to do this frequently?  If so, why is that? why not
set the size that is convenient for you, and more or less forget about
it?

I guess I don't understand why one would need to change the size
frequently, especially the size of the menu items, which basically
stay unchanged.

> Then there seems to be the issue you said that Emacs and X has different
> idea of describing fonts/units.
> 
> It is just complex and inconvenient.

But you should only need to do this once, or very infrequently.  So
how is this such a grave problem?

> > More generally, I don't see a way around the fact that different parts
> > of the system need to be customized differently.
> 
> Why?

Because they are different subsystems developed by different agencies
with different goals in mind.

> > Many programs have
> > their own init files, and some even have more than one: for example,
> > Bash, GDB, and any other program that uses Readline will typically
> > have customizations in ~/.inputrc, in addition to the program-specific
> > init file, such as ~/.gdbinit for GDB.
> 
> This is not only about init files.
> 
> This is about making it not to have more init files, because unlike
> customizing and changing faces, customizing a different system out of
> Emacs is complex, fragile, inconvenient and might be impossible (is it
> possible to change the menu text X resource on key press?).

I find it neither complex nor fragile: just edit a file, and that's
it.  If it's something you don't need to do frequently (as I think
what should happen with font sizes), it's a fire-and-forget thing.